ALTER TABLE NNPOMOL
ADD TRANSPARENTNOST VARCHAR2(1 CHAR);

CREATE OR REPLACE VIEW V_KUPCI_BALANCE AS (
  SELECT VKS.V_KUPCI_SALDAKONTI_ID AS V_KUPCI_BALANCE_ID, VKS.KUPCI_ID, VKS.NNFIRMA_ID, VKS.KUPCI_IME, VKS.KUPCI_PRIIMEK, VKS.SALDAKONTI_SIT, VKS.SALDAKONTI_DEM,
  -- Balance
  CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_DEM, 0) END AS BALANCE,
  
  -- Commercial balance
  CASE 
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'PartialProformaInvoices') = '1' THEN
      (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_PART_PROFORMA_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_PART_PROFORMA_DEM, 0) END)
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'UpostevanjePredracunovVSaldu') = '1' THEN
      (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(-VKS.SALDAKONTI_PROFORMA_SIT, 0) ELSE COALESCE(-VKS.SALDAKONTI_PROFORMA_DEM, 0) END)
    ELSE 
      0
    END AS COMMERCIAL_BALANCE,
    
  -- Received balance
  CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_RECEIVED_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_RECEIVED_DEM, 0) END AS RECEIVED_BALANCE,
  
  -- Outstanding balance
  CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_OUTSTANDING_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_OUTSTANDING_DEM, 0) END AS OUTSTANDING_BALANCE,
  
  -- Deposits
  CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.DEPOSIT_SIT, 0) ELSE COALESCE(VKS.DEPOSIT_DEM, 0) END AS DEPOSIT,
  
  -- Total balance (balance + commercial balance)
  (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_DEM, 0) END) +
  (CASE 
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'PartialProformaInvoices') = '1' THEN
      (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_PART_PROFORMA_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_PART_PROFORMA_DEM, 0) END)
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'UpostevanjePredracunovVSaldu') = '1' THEN
      (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(-VKS.SALDAKONTI_PROFORMA_SIT, 0) ELSE COALESCE(-VKS.SALDAKONTI_PROFORMA_DEM, 0) END)
    ELSE 
      0
    END) AS TOTAL_BALANCE
  FROM V_KUPCI_SALDAKONTI VKS
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1097, SYSDATE, '5.5', 1017, 'Pomol transparentnost')
;
