DROP VIEW V_POGODBE;

CREATE OR REPLACE VIEW V_POGODBE AS (
	SELECT P.ID_POGODBE AS V_POGODBE_ID, P.ID_POGODBE, P.ID_LASTNIKA, P.ID_PLOVILA, P.ID_MASTER, P.OBJEKT, P.N_PRIVEZA, P.N_POGODBE, P.DATUM_ZACETKA, P.DATUM_KONCA, P.PREDVIDENI_DATUM_KONCA, P.DATUM_KREIRANJA, P.USER_KREIRANJA,
  P.DATUM_SPREMEMBE, P.USER_SPREMEMBE, P.STATUS, P.DATUM_SKLENITVE, P.DATUM_PREKINITVE, P.KOMENTAR, P.TIP_POGODBE, P.EXTENSION_SEQUENCE_NUMBER, P.EXTENSION_DATE, P.ID_PRIVEZ,
  NNSTAT.OPIS AS STATUS_OPIS, NNSTAT.INTERNI_OPIS AS STATUS_INTERNI_OPIS,
  PLOV.IME AS PLOVILA_IME, PLOV.PODALJSA AS PLOVILA_PODALJSA, KUP.IME AS KUPCI_IME, KUP.PRIIMEK AS KUPCI_PRIIMEK, KUP.INT_CODE AS KUPCI_INT_CODE, KUP.VRSTA AS KUPCI_VRSTA,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KUP.IME || ' ' || KUP.PRIIMEK) ELSE (KUP.PRIIMEK || ' ' || KUP.IME) END) AS OWNER,
  NP.ID_PRIVEZ AS NNPRIVEZ_ID_PRIVEZ, NP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_PRIVEZ, NP.DOLZINA AS NNPRIVEZ_DOLZINA, NO.STORAGE AS NNOBJEKT_STORAGE, NNLOC.ID AS NNLOCATION_ID
	FROM M_POGODBE P
	LEFT OUTER JOIN NNSTATPOG NNSTAT ON P.STATUS = NNSTAT.SIFRA
  LEFT OUTER JOIN PLOVILA PLOV ON PLOV.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KUP ON KUP.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = P.ID_PRIVEZ
  LEFT OUTER JOIN NNOBJEKT NO ON NO.SIFRA = NP.OBJEKT 
  LEFT OUTER JOIN NNPOMOL NPOM ON NPOM.SIFRA = NP.KATEGORIJA
  LEFT OUTER JOIN NNLOCATION NNLOC ON NNLOC.ID = NPOM.NNLOCATION_ID
);

DROP VIEW V_RESERVATION;

CREATE OR REPLACE VIEW V_RESERVATION AS (
  SELECT RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR, RE.DATUM_REZERVACIJE, RE.DATUM_DO, RE.PRIVEZ, RE.ID_PRIVEZ, RE.ODPOVED, NNPR.NNLOCATION_ID,
  DE.ID_REZERVAC_DETAIL AS REZERVAC_DETAIL_ID, DE.DATUM_OD AS REZERVAC_DETAIL_DATUM_OD, DE.DATUM_DO AS REZERVAC_DETAIL_DATUM_DO, DE.STATUS_REZERVAC AS REZERVAC_DETAIL_STATUS, DE.COMPLETE AS REZERVAC_DETAIL_COMPLETE,
  NND.N_PRIVEZA AS REZERVAC_DETAIL_PRIVEZ, NND.ID_PRIVEZ AS REZERVAC_DETAIL_ID_PRIVEZ, NND.OCCUPANCY_STATISTICS AS REZERVAC_DETAIL_OCC_STAT, NNPD.NNLOCATION_ID AS REZERVAC_DETAIL_NNLOCATION_ID, 
  KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) END) AS OWNER,
  (CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DATUM_ZAVAROVANJE ELSE PL.DATUM_ZAVAROVANJE END) AS DATUM_ZAVAROVANJE,
  (CASE WHEN RE.STATUS_REZERVAC IN (0, 1, 2) THEN 'Y' ELSE 'N' END) AS RECEIVED,
  (CASE WHEN RE.STATUS_REZERVAC = 0 THEN 'Y' ELSE 'N' END) AS DEPARTED
  FROM REZERVAC RE
  JOIN REZERVAC_DETAIL DE ON RE.ID = DE.ID_REZERVAC
  LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
  LEFT OUTER JOIN NNPRIVEZ NND ON NND.ID_PRIVEZ = DE.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNPD ON NNPD.SIFRA = NND.KATEGORIJA
  LEFT OUTER JOIN NNPRIVEZ NNR ON NNR.ID_PRIVEZ = RE.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNPR ON NNPR.SIFRA = NNR.KATEGORIJA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1601, SYSDATE, '5.5', 1521, 'Views')
;
